Botan: Botan::ARC4 Class Reference

Botan 1.10.12

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
Botan::ARC4 Class Reference

`#include <arc4.h>`

Inheritance diagram for Botan::ARC4:

## Public Member Functions
| ARC4 (size_t skip=0)
void | cipher (const byte in[], byte out[], size_t length)
void | cipher1 (byte buf[], size_t len)
void | clear ()
StreamCipher * | clone () const
Key_Length_Specification | key_spec () const
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
virtual void | set_iv (const byte iv[], size_t iv_len)
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
virtual bool | valid_iv_length (size_t iv_len) const
bool | valid_keylength (size_t length) const
| ~ARC4 ()

## Detailed Description

Alleged RC4

Definition at line 19 of file arc4.h.

## Constructor & Destructor Documentation

Botan::ARC4::ARC4 | ( | size_t | skip = `0` | ) |

Parameters

  skip | skip this many initial bytes in the keystream

Definition at line 104 of file arc4.cpp.

References clear().

104 : SKIP(s),
105 state(256),
106 buffer(DEFAULT_BUFFERSIZE)
107 {
108 clear();
109 }
Botan::ARC4::clear
void clear()
Definition: arc4.cpp:94

Botan::ARC4::~ARC4 | ( |  | ) |
| inline

Definition at line 39 of file arc4.h.

39 { clear(); }
Botan::ARC4::clear
void clear()
Definition: arc4.cpp:94

## Member Function Documentation

void Botan::ARC4::cipher | ( | const byte | in[],
|  | byte | out[],
|  | size_t | len
| ) |  |
| virtual

Encrypt or decrypt a message

Parameters

  in | the plaintext
  out | the byte array to hold the output, i.e. the ciphertext
  len | the length of both in and out in bytes

Implements Botan::StreamCipher.

Definition at line 17 of file arc4.cpp.

References clear(), Botan::MemoryRegion< T >::size(), std::swap(), and Botan::xor_buf().

18 {
19 while(length >= buffer.size() - position)
20 {
21 xor_buf(out, in, &buffer[position], buffer.size() - position);
22 length -= (buffer.size() - position);
23 in += (buffer.size() - position);
24 out += (buffer.size() - position);
25 generate();
26 }
27 xor_buf(out, in, &buffer[position], length);
28 position += length;
29 }
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29
Botan::xor_buf
void xor_buf(byte out[], const byte in[], size_t length)
Definition: xor_buf.h:21

void Botan::StreamCipher::cipher1 | ( | byte | buf[],
|  | size_t | len
| ) |  |
| inlineinherited

Encrypt or decrypt a message

Parameters

  buf | the plaintext / ciphertext
  len | the length of buf in bytes

Definition at line 34 of file stream_cipher.h.

Referenced by Botan::Lion::decrypt_n(), and Botan::Lion::encrypt_n().

35 { cipher(buf, buf, len); }
Botan::StreamCipher::cipher
virtual void cipher(const byte in[], byte out[], size_t len)=0

void Botan::ARC4::clear | ( |  | ) |
| virtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 94 of file arc4.cpp.

References Botan::zeroise().

Referenced by ARC4(), and cipher().

95 {
96 zeroise(state);
97 zeroise(buffer);
98 position = X = Y = 0;
99 }
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:415

StreamCipher* Botan::ARC4::clone | ( |  | ) | const
| inlinevirtual

Get a new object representing the same algorithm as *this

Implements Botan::StreamCipher.

Definition at line 27 of file arc4.h.

27 { return new ARC4(SKIP); }
Botan::ARC4::ARC4
ARC4(size_t skip=0)
Definition: arc4.cpp:104

Key_Length_Specification Botan::ARC4::key_spec | ( |  | ) | const
| inlinevirtual

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 29 of file arc4.h.

30 {
31 return Key_Length_Specification(1, 256);
32 }

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inlineinherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

Referenced by Botan::Cascade_Cipher::decrypt_n(), Botan::PBE_PKCS5v20::end_msg(), and Botan::ANSI_X931_RNG::randomize().

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inlineinherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

std::string Botan::ARC4::name | ( |  | ) | const
| virtual

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 84 of file arc4.cpp.

References Botan::to_string().

85 {
86 if(SKIP == 0) return "ARC4";
87 if(SKIP == 256) return "MARK-4";
88 else return "RC4_skip(" + to_string(SKIP) + ")";
89 }
Botan::to_string
std::string to_string(u64bit n, size_t min_len)
Definition: parsing.cpp:42

void Botan::StreamCipher::set_iv | ( | const byte | iv[],
|  | size_t | iv_len
| ) |  |
| virtualinherited

Resync the cipher using the IV

Parameters

  iv | the initialization vector
  iv_len | the length of the IV in bytes

Reimplemented in Botan::WiderWake_41_BE, Botan::CTR_BE, Botan::OFB, Botan::Salsa20, and Botan::Turing.

Definition at line 12 of file stream_cipher.cpp.

References Botan::Algorithm::name().

Referenced by Botan::EAX_Base::set_iv(), and Botan::StreamCipher_Filter::set_iv().

13 {
14 if(iv_len)
15 throw Invalid_Argument("The stream cipher " + name() +
16 " does not support resyncronization");
17 }
Botan::Invalid_Argument
std::invalid_argument Invalid_Argument
Definition: exceptn.h:20
Botan::Algorithm::name
virtual std::string name() const =0

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_package(), Botan::aont_unpackage(), Botan::GOST_34_11::clear(), Botan::CTR_BE::clear(), Botan::OFB::clear(), Botan::Cascade_Cipher::decrypt_n(), Botan::DESX::decrypt_n(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::CMAC::poly_double(), Botan::ANSI_X931_RNG::randomize(), Botan::Randpool::randomize(), Botan::HMAC_RNG::reseed(), Botan::EAX_Base::set_key(), Botan::XTS_Encryption::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), Botan::StreamCipher_Filter::StreamCipher_Filter(), Botan::DLIES_Decryptor::~DLIES_Decryptor(), and Botan::DLIES_Encryptor::~DLIES_Encryptor().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

bool Botan::StreamCipher::valid_iv_length | ( | size_t | iv_len | ) | const
| virtualinherited

Parameters

  iv_len | the length of the IV in bytes

Returns
  if the length is valid for this algorithm

Reimplemented in Botan::WiderWake_41_BE, Botan::CTR_BE, Botan::OFB, Botan::Salsa20, and Botan::Turing.

Definition at line 19 of file stream_cipher.cpp.

20 {
21 return (iv_len == 0);
22 }

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inlineinherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_package(), Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), Botan::Lion::Lion(), Botan::Randpool::Randpool(), and Botan::EAX_Base::valid_keylength().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51

The documentation for this class was generated from the following files:

- src/stream/arc4/arc4.h
- src/stream/arc4/arc4.cpp